BaseArnl: ArBaseLocalizationTask Class Reference

- Main Page
- Classes
- Related Pages
- Examples

- Class List
- Class Hierarchy
- Class Members

# ArBaseLocalizationTask Class Reference

`#include <ArBaseLocalizationTask.h>`

Inheritance diagram for ArBaseLocalizationTask:

List of all members.

## Detailed Description

This class has the similar items of ArLocalizationTask and ArSonarLocalizationTask, right now thats just one enum, later it may grow to become more.

## Public Types
enum | LocalizationState { , LOCALIZATION_FAILED, LOCALIZATION_SUCCESS, LOCALIZATION_INIT_COMPUTING, LOCALIZATION_MOVE_COMPUTING, LOCALIZATION_IDLE, INVALID }
| State of the path plan, accessible using getState(). More...
## Public Member Functions
virtual bool | findLocalizationMeanVar (ArPose &mean, ArMatrix &var)
| Function returns what the current mean pose and its variance.
virtual void | setCorrectRobotFlag (bool f)
| Used to switch off moveTo inside the child localization tasks.
virtual void | setRobotPose (ArPose pose, ArPose spread=ArPose(-1.,-1.,-1.), int nSam=-1)
| Used to set the robot pose usually at the start of localization.
virtual bool | getRobotIsLostFlag ()
| Finds if the robot is lost.
virtual ArPose | getRobotHome ()
| Gets the robot home pose This pose is the initial best localized position determined by localizeRobotAtHomeBlocking() or localizeRobotAtHomeNonBlocking() methods.
ArRetFunctor< ArPose > * | getRobotHomeCallback ()
| Get a functor that when called returns the robot's home pose This pose is the initial best localized position determined by localizeRobotAtHomeBlocking() or localizeRobotAtHomeNonBlocking() methods.
ArPose | getHomePose ()
virtual bool | localizeRobotAtHomeBlocking (double distSpread, double angleSpread)
| Localize robot at start or while initialization.
virtual bool | localizeRobotAtHomeBlocking ()
| Try localizing at each home position, choosing the best to be the current and the stored "home" position.
virtual std::list< ArPose > | getCurrentSamplePoses ()
| Gets the current sample poses if relevant.
virtual LocalizationState | getState (void)
| Get the localization state.
virtual double | getLocalizationScore (void)
| Get the localization score.
virtual double | getLocalizationThreshold (void)
| Get the localization threshold.
virtual bool | checkLocalizationIdle (void)
| Get the localization idle.
virtual void | setLocalizationIdle (bool f)
| Set the localization idle.
virtual void | setLocalizationThreshold (double t)
| Set the localization threshold.
virtual ArTransform | getEncoderToLocalizationTransform (void)
| Get the robot encoder to the localization pose transform.
const char * | getName (void)
| Gets the name of this task.
virtual int | getPoseInterpPosition (ArTime timeStamp, ArPose *position)
| See also: ArInterpolation::getPose
ArRetFunctor2< int, ArTime, ArPose * > * | getPoseInterpPositionCallback (void)
| Gets the callback that will call getPoseInterpPosition.
virtual bool | convertLLA2RobotCoords (double lat, double lon, double alt, double &ea, double &no, double &up)
| Convert LLA to Robot.
virtual bool | convertRobot2LLACoords (double ea, double no, double up, double &lat, double &lon, double &alt)
| Convert Robot to LLA.

## Member Enumeration Documentation

enum ArBaseLocalizationTask::LocalizationState

State of the path plan, accessible using getState().

Enumerator:

  LOCALIZATION_FAILED | Task not initialized.
  LOCALIZATION_SUCCESS | Failed localization.
  LOCALIZATION_INIT_COMPUTING | Failed to reach goal because superseded.
  LOCALIZATION_MOVE_COMPUTING | Localization init in progress.
  LOCALIZATION_IDLE | Localization move in progress.
  INVALID | Invalid state.

## Member Function Documentation

virtual void ArBaseLocalizationTask::setRobotPose | ( | ArPose | pose,
|  | ArPose | spread = `ArPose(-1., -1., -1.)`,
|  | int | nSam = `-1` |
| ) |  |  | `[inline, virtual]`

Used to set the robot pose usually at the start of localization.

This one with a spread around the set pose.

Reimplemented in ArLocalizationManager.

ArPose ArBaseLocalizationTask::getHomePose | ( |  | ) | `[inline]`

Deprecated: